// Initialize kernel GDT.
// Copyright (c) 2001, David H. Hovemeyer <daveho@cs.umd.edu>
// $Revision: 1.2 $

// This is free software.  You are permitted to use,
// redistribute, and modify it as specified in the file "COPYING".

#include "gdt.h"

#define GDT_ENTRY_SZ 8
#define NUM_GDT_ENTRIES 3 // for now; will increase later

// This is defined in lowlevel.asm.
extern void Load_GDTR( unsigned short* limitAndBase );

unsigned long long s_GDT[3] = {
    0x0000000000000000ULL,
    0x00CF9A000000FFFFULL,	// kernel code segment
    0x00CF92000000FFFFULL,	// kernel data segment
};

void Init_GDT( void )
{
    unsigned short limitAndBase[3];
    unsigned long gdtBaseAddr = (unsigned long) s_GDT;

    limitAndBase[0] = GDT_ENTRY_SZ * NUM_GDT_ENTRIES;
    limitAndBase[1] = gdtBaseAddr & 0xffff;
    limitAndBase[2] = gdtBaseAddr >> 16;

    Load_GDTR( limitAndBase );
}
